-----
-- Created by FirefoxMetzger
-- V 1.0.2
-----
 
-----------------------------------------------------------------------------------------------
-- PCB Module Definition
-----------------------------------------------------------------------------------------------
local PCB = {} 

-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function PCB:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    return o
end

function PCB:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
		"ChatLog"
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 
-----------------------------------------------------------------------------------------------
-- PCB OnLoad
-----------------------------------------------------------------------------------------------
function PCB:monkeyInit()
	Apollo.StopTimer("PCBmonkeyT")
	
	local adChat = Apollo.GetAddon("ChatLog")
	
	adChat.OnWndMainMouseEnter	= function (self, wndHandler, wndControl)
		local inputWindow = wndHandler:GetParent():FindChild("Input")

		if not inputWindow:IsShown() and GameLib.GetPlayerUnit():IsInCombat() then
			inputWindow:Show(true)
		end
	
		-- carbine part of the function
		if wndHandler:GetData() then -- Because UseParentOpacity is BGColor not TextColor
			for idx, wndCurr in pairs(wndHandler:GetData()) do
				wndCurr:Show(true)
			end
		end
	end
	
	PCB.oldOnInputGainedFocus = adChat.OnInputGainedFocus -- save the old function
	adChat.OnInputGainedFocus = function (self, wndHandler, wndControl)
		if not wndHandler == wndControl then
			return
		end
		
		if not GameLib.GetPlayerUnit():IsInCombat() then
			wndHandler:Show(true)
			PCB.oldOnInputGainedFocus(self, wndHandler, wndControl) -- no combat --> normal chat window
		else
			wndHandler:Show(false) -- in combat --> chat input can't become focus
		end
	end
end

function PCB:OnLoad()
    Apollo.RegisterTimerHandler("PCBmonkeyT", "monkeyInit", self) --not 100% sure if the timer is needed
    Apollo.CreateTimer("PCBmonkeyT", 1, false)					-- failed loading a view times while not having it
    Apollo.StartTimer("PCBmonkeyT")
end

-----------------------------------------------------------------------------------------------
-- PCB Instance
-----------------------------------------------------------------------------------------------
local PCBInst = PCB:new()
PCBInst:Init()
